/*
 * Copyright 2009-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.logstats.ejb.services;


import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.Resource;
//import javax.annotation.security.RolesAllowed;
import javax.ejb.EJB;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import net.forwardfire.logstats.ejb.models.LogRightRole;
import net.forwardfire.logstats.ejb.models.LogUser;
import net.forwardfire.logstats.ejb.models.LogUserRightRole;

import net.forwardfire.vasc.xpql.ejb3.XpqlQueryManager;
import net.forwardfire.vasc.xpql.query.Query;


/**
 * An simple ejb bean to force an login.
 * 
 * @author Willem Cazander
 * @version 1.0 16 Jul 2007
 */
@Stateless(name="ejb/loginManager")
public class LoginManager implements LoginManagerRemote {

    @Resource
    private SessionContext session;
    
    @EJB(beanInterface=XpqlQueryManager.ILocal.class)
    private XpqlQueryManager xtesManager;

    @PersistenceContext
	private EntityManager entityManager;
    
    /**
     * Tests for the login role
     */
    //@RolesAllowed("login")
    public String doClientLogin() {
    	/*
    	FlowUser u = null;
    	try {
    		u = getUser();
    	} catch (Exception e) {
    		throw new IllegalStateException("Could not lookup user from username: "+session.getCallerPrincipal().getName());
    	}
    	FlowUserSession us = new FlowUserSession();
    	us.setLoginDate(new Date());
    	us.setLogoutDate(null); // set when doing doClientLogout();

    	// current_time_in_secs + str_to_int(username)*10E20
    	long timeSS = us.getLoginDate().getTime();
    	int userSS = hashUserName(u.getUsername());
    	int modSS = 10230;
    	long sessionId = timeSS+userSS*modSS;
    	us.setSessionHash(sessionId+"");
    	//System.out.println("Created sessionId: timeSS: "+timeSS+" userSS: "+userSS+" modSS: "+modSS);
    	
    	us.setFlowUser(u);
    	entityManager.persist(us);
    	return u.getUsername();
    	*/
    	return "";
    }
    
    //@RolesAllowed("login")
    public void doClientLogout() {
    	try {
    		/*
    		Query q2 = xtesManager.getQuery("FlowUserSession.getLastestByUserName");
    		q2.setQueryParameter("username", session.getCallerPrincipal().getName());
    		q2.setProperty("limit", 1);
    		FlowUserSession userSession =  (FlowUserSession)xtesManager.executeObject(q2);
    		userSession.setLogoutDate(new Date());
    		entityManager.merge(userSession);
    		*/
    	} catch (Exception e) {
    		e.printStackTrace();
    	}
    }
    
    
    private int hashUserName(String userName) {
    	int result = 0;
    	for (char c:userName.toCharArray()) {
    		result+=c;
    	}
    	return result;
    }
    
    /**
     * Gets the currenly auth user
     */
    //@RolesAllowed("login")
    public LogUser getUser() throws Exception {
    	
    	if (session.getCallerPrincipal()==null) {
    		return null;
    	}
    	Query q = xtesManager.getQuery("LogUser.getByUsername");
    	q.setQueryParameter("username", session.getCallerPrincipal().getName());
    	return (LogUser)xtesManager.executeObject(q);
    }
    
    
    /**
     * Fetched the roles for the logged in client
     * @return
     */
    //@RolesAllowed("login")
    public List<LogRightRole> getClientRoles() throws Exception {
    	List<LogRightRole> result = new ArrayList<LogRightRole>(5);
    	Query q = xtesManager.getQuery("LogRightRole.getAllByUsername");
    	q.setQueryParameter("username", session.getCallerPrincipal().getName());
    	List<Object> list = xtesManager.execute(q);
    	for (Object o:list) {
    		LogRightRole rr = ((LogRightRole)o);
    		result.add(rr);
    	}
    	return result;
    }
}
